#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>
#include <unistd.h>
#include <errno.h>
#include <sys/stat.h>
#include <string.h>
#include <stdlib.h>

#include "treepage.h"

int
scan_dirs (char *name, struct node *parent)
{
  DIR *dir;
  char path[0x100];
  struct dirent *dirent;
  struct stat st;
  struct node *n;

  dir = opendir (name);
  if (dir == 0)
    {
      perror (name);
      return -1;
    }

  while (dirent = readdir (dir))
    {
      strcpy (path, name);
      strcat (path, "/");
      strcat (path, dirent->d_name);
      if (stat (path, &st) < 0)
	{
	  perror (path);
	  return -1;
	}
      if (dirent->d_name[0] == '.')	/* Skip .hidden directories */
	continue;
      if (!S_ISDIR (st.st_mode))	/* Skip files */
	continue;

      n = new_node (parent);
      n->name = strdup (dirent->d_name);
      if (!n->name)
	return -1;
      n->path = strdup (path);
      if (!n->path)
	return -1;

      add_node (n, parent);

      scan_dirs (path, n);
    }

  closedir (dir);
  return 0;
}
