#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "treepage.h"

static int
_gen_tree0 (struct node *node, struct node *current, FILE * f)
{
  struct node *n;
  int x;

  if (node->parent)
    {
      _gen_tree0 (node->parent, current, f);
      n = node->parent;
      if (n)
	n = n->child;

      while (n)
	{
	  if (strcmp (n->name, node->name) <= 0)
	    {
	      for (x = 0; x < n->level - 1; x++)
		fprintf (f, "&nbsp;&nbsp;&nbsp;&nbsp;");

	      fprintf (f, "<img src=\"");
	      for (x = 0; x < current->level; x++)
		fprintf (f, "../");
	      fprintf (f, "icon.gif\">");

	      fprintf (f, "<a href=\"");
	      for (x = current->level; x >= n->level; x--)
		fprintf (f, "../");
	      fprintf (f, "%s/index.html\">%s</a>",
                   n->name,
                   getsval (n, "name", n->name));

	      fprintf (f, "<br>\n");
	    }
	  n = n->next;
	}
    }
  return 0;
}

static int
_gen_tree1 (struct node *node, struct node *current, FILE * f)
{
  struct node *n;
  int x;

  if (node->parent)
    {
      n = node->parent;
      if (n)
	n = n->child;

      while (n)
	{
	  if (strcmp (n->name, node->name) > 0)
	    {
	      for (x = 0; x < n->level - 1; x++)
		fprintf (f, "&nbsp;&nbsp;&nbsp;&nbsp;");

	      fprintf (f, "<img src=\"");
	      for (x = 0; x < current->level; x++)
		fprintf (f, "../");
	      fprintf (f, "icon.gif\">");

	      fprintf (f, "<a href=\"");
	      for (x = current->level; x >= n->level; x--)
		fprintf (f, "../");
	      fprintf (f, "%s/index.html\">%s</a>",
		       n->name,
		       getsval (n, "name", n->name));

	      fprintf (f, "<br>\n");
	    }
	  n = n->next;
	}
      _gen_tree1 (node->parent, current, f);
    }
  return 0;
}

static int
_gen_tree (struct node *node, FILE * f)
{
  struct node *n;
  int x;


  _gen_tree0 (node, node, f);
  n = node->child;
  while (n)
    {
      for (x = 0; x < n->level - 1; x++)
	fprintf (f, "&nbsp;&nbsp;&nbsp;&nbsp;");

      fprintf (f, "<img src=\"");
      for (x = 0; x < node->level; x++)
	fprintf (f, "../");
      fprintf (f, "icon.gif\">");

      fprintf (f, "<a href=\"%s/index.html\">%s</a>", 
                  n->name,
                  getsval (n, "name", n->name));
      fprintf (f, "<br>\n");
      n = n->next;
    }
  _gen_tree1 (node, node, f);
  return 0;
}

static int
__gen (struct node *node)
{
  char pname[0x100];
  FILE *f, *bdy;
  char buf[1024];
  int nread;

  strcpy (pname, node->path);
  strcat (pname, "/index.html");
  printf ("%s\n", pname);
  f = fopen (pname, "w");
  if (!f)
    {
      perror (pname);
      return -1;
    }

  fprintf (f,"<html><head><title>%s</title></head><body bgcolor=#ffffff text=#000000>", getsval(node,"title","Noname"));
  fprintf (f, "<table border=0 width=100%%><tr><td valign=top width=85%%>");

  fprintf (f,"<h1>%s</h1>", getsval(node,"title","(No title for page)"));
  strcpy (pname, node->path);
  strcat (pname, "/body.html");
  bdy = fopen (pname, "r");
  if (bdy)
    {
      while ((nread = fread (buf, 1, 1024, bdy)) > 0)
	fwrite (buf, nread, 1, f);
      fclose (bdy);
    }
  else
    fprintf (f, "Index for %s<p>", node->name);


  fprintf (f, "<td bgcolor=lightblue width=15%% valign=top>Filesystems collection<p>");

  _gen_tree (node, f);

  fprintf (f, "<hr width=75%%>");
  fprintf (f, "<center>[Main page]</center>");
  fprintf (f, "<center>[FAQ]</center>");
  fprintf (f, "<center>[Related sites]</center>");
  fprintf (f, "<center>[Feedback]</center>");

  fprintf (f, "<hr width=75%%>");
  fprintf (f, "<center><font size=-1>Copyright</font></center>"
	   "<center><font size=-1>(c) 1999</font></center>"
	   "<center><font size=-1><a href=\"http://www.penguin.cz/~mhi/\">Martin Hinner</a></font></center>"
	   "<center><font size=-1>&lt;<a href=\"mailto:mhi@penguin.cz\">mhi@penguin.cz</a>&gt;</font></center>");

  fprintf (f, "</td></table>");

  fclose (f);
  return 0;
}

int
gen_nodeindex (struct node *node)
{
  struct node *n;
  int x;

  if (!node)
    return 0;

  n = node;
  while (n)
    {
      __gen (n);
      if (n->child)
	gen_nodeindex (n->child);
      n = n->next;
    }
  return 0;
}


int
gen_index ()
{
  gen_nodeindex (root);
}
