#include <stdio.h>
#include <string.h>
#include <malloc.h>

#include "metapage.h"

char *
getsval (struct node *node, char *name, char *defaultv)
{
  struct value *val;

  val = node->values;
  while (val)
    {
      /* DEBUG: printf("%s=%s\n",val->name,val->value); */
      if (!strcmp (name, val->name))
	return val->value;
      val = val->next;
    }
  return defaultv;
}

int 
setsval (struct node *node, char *name, char *value)
{
  struct value *val;

  val = (struct value *) malloc (sizeof (struct value));
  if (!val)
    return -1;

  val->name = strdup (name);
  if (!val->name)
    {
      free (val);
      return -1;
    }

  val->value = strdup (value);
  if (!val->value)
    {
      free (val->name);
      free (val);
      return -1;
    }
  val->next = node->values;
  node->values = val;

  return 0;
}


static int
__load (struct node *node)
{
  char pname[0x100];
  FILE *f;
  char buf[1024];
  char *vname;
  char *value;
  int lineno;

  strcpy (pname, node->path);
  strcat (pname, "/.info");
  f = fopen (pname, "r");
  if (!f)
    {
      return -1;
    }

  printf ("info:%s\n", pname);
  lineno = 0;
  while (fgets (buf, 1024, f))
    {
      lineno++;
      if (strchr (buf, '\n'))
	*strchr (buf, '\n') = 0;
      if (!buf[0])
	continue;
      if (!strchr (buf, '='))
	{
	  fprintf (stderr, "%s(%u): '=' expected.\n", pname, lineno);
	  exit (1);
	}
      vname = buf;
      value = strchr (buf, '=') + 1;
      *(value - 1) = 0;
      printf("%s:%s:%s\n",pname,vname,value);
      setsval (node, vname, value);
    }
  fclose (f);
  return 0;
}

int
load_nodeinfo (struct node *node)
{
  struct node *n;
  int x;

  if (!node)
    return 0;

  n = node;
  while (n)
    {
      __load (n);
      if (n->child)
	load_nodeinfo (n->child);
      n = n->next;
    }
  return 0;
}


int 
load_info ()
{
  return load_nodeinfo (root);
}
