#include "config.h"

#include <stdio.h>

#ifdef HAVE_GETOPT_H
#include <getopt.h>
#else
#include "getopt.h"
#endif


#include "treepage.h"


char *usage =
"Usage: %s [directory]\n"
"\n"
"This program generates indexes for metalab.unc.edu/filesystems/\n";

char *argv0;


int
main (int argc, char **argv)
{
  char c;

  argv0 = argv[0];

  while ((c = getopt (argc, argv, "hV")) != -1)
    {
      switch (c)
	{
	case 'h':
	  fprintf (stderr, usage, argv0);
	  exit (0);
	case 'V':
	  fprintf (stderr, "metapage version %s, compiled %s\n",
		   version, compile_date);
	  exit (0);
	default:
	  fprintf (stderr, usage, argv0);
	  exit (1);
	}
    }

  argc -= optind;
  argv += optind;

  if (argc == 0)
    {
      fprintf (stderr, usage, argv0);
      exit (1);
    }

  alloc_root_node (argv[0]);
  scan_dirs (argv[0], root);
  load_info ();
  gen_index ();
  return 0;
}
