#include <stdio.h>
#include <malloc.h>
#include <string.h>

#include "treepage.h"

struct node *root;

struct node *
new_node (struct node *parent)
{
  struct node *n;

  n = (struct node *) malloc (sizeof (struct node));
  if (!n)
    return -1;
  n->name = 0;
  n->child = 0;
  n->next = 0;
  n->values = 0;
  if (parent)
    n->level = parent->level + 1;
  else
    n->level = 0;
  n->parent = parent;
  return n;
}

int
alloc_root_node (char *path)
{
  root = new_node (0);
  if (!root)
    return -1;
  root->path = strdup (path);
  if (!root->path)
    return -1;

  return 0;
}

int
add_node (struct node *node, struct node *parent)
{
  struct node *n, *pn;

  /* printf ("add_node('%s','%s');\n", node->name, parent->name); */

  node->parent = parent;

  if (!parent->child)
    {
      parent->child = node;
      node->next = 0;
      return 0;
    }

  if (strcmp (parent->child->name, node->name) >= 0)
    {
      node->next = parent->child;
      parent->child = node;
      return 0;
    }

  n = parent->child;
  while (n)
    {
      if (n->next)
	if ((strcmp (n->next->name, node->name) > 0) &&
	    (strcmp (n->name, node->name) < 0))
	  {
	    node->next = n->next;
	    n->next = node;
	    return 0;
	  }
      pn = n;
      n = n->next;
    }

  node->next = 0;
  pn->next = node;
  return 0;
}
